module Rulz
  module Conditions    
    module Comparison
      
      def self.load_conditions(reciever, attr)
        reciever.class_eval do
          define_rulz do
            attribute attr do
              condition "greater than" do |other|
                send(attr) > other
              end
        
              condition "less than" do |other|
                send(attr) < other
              end
        
              condition "equal to" do |other|
                send(attr) == other
              end
        
              condition "not equal to" do |other|
                opposite_of "equal to", other
              end              
            end
          end
        end
      end
      
      def self.included(base)
        base.class_eval do
          define_rulz do        
            condition "greater than" do |other|
              it > other
            end
        
            condition "less than" do |other|
              it < other
            end
        
            condition "equal to" do |other|
              it == other
            end
        
            condition "not equal to" do |other|
              opposite_of "equal to", other
            end
          end
        end
      end
    end
  end
end