module Rulz
  class Rule
    attr_accessor :proc
    
    def initialize(klass, proc)
      @proc = proc
      klass.instance_exec self do |rule| 
        @rulz_rules ||= []
        @rulz_rules << rule
      end
    end
    
    def apply!(receiver)
      Rulz::Evaluator::Rule.new(receiver, @proc).evaluate
    end
    
    def self.rules(klass)
      klass.instance_eval { @rulz_rules }
    end
  end
end